// automate de Griffeath à 4 etats codés 0,1,2,3
// PC mars 2020

int DIM = 300;
float R;

int[][]C = new int[DIM][DIM];
int[][]D = new int[DIM][DIM];
int i,j;
float x,y;

void setup(){
  size(600,600);
  noStroke();
  R = width/DIM;
  //frameRate(1);  
  for (i=0;i<DIM;i++)
   for (j=0;j<DIM;j++){
     // au debut les 4 etats sont equi-probables
     C[i][j] = int(random(0,4));
   }
}

void draw(){
 background(120);
 // calcul nvelle etape
 for (i=0;i<DIM;i++)
  for (j=0;j<DIM;j++){
   // condition de Griffeath
   if (Griffeath(i,j)) D[i][j]=(C[i][j]+1)%4;
   // sinon pas de changement
   else D[i][j]=C[i][j];
  }
 // affichage resultat
 x = R/2; y = R/2;
 for (i=0;i<DIM;i++){
  for (j=0;j<DIM;j++){
    if (D[i][j]==0) fill(252,255,2);  // jaune
    else if (D[i][j]==1) fill(254,171,0); // orange clair
    else if (D[i][j]==2) fill(255,55,0); // orange foncé
    else fill(255,55,0); // rouge
    ellipse(x,y,R,R);
    x += R;
   }
   y += R;x = R/2;
 }
 
 // recopie etat courant
 for (i=0;i<DIM;i++) for (j=0;j<DIM;j++) C[i][j]=D[i][j];

 println(frameCount);
}

void keyPressed(){
  noLoop();
  save("jeu"+frameCount+".png");
}

boolean Griffeath(int i, int j) {
 // coordonnees voisins
 int im1 = (i == 0)?DIM-1:i-1;
 int ip1 = (i == DIM-1)?0:i+1;
 int jm1 = (j == 0)?DIM-1:j-1;
 int jp1 = (j == DIM-1)?0:j+1;
 // comptages des etats, on fait un histogramme pour la repartition des etats
 int histo[] = {0,0,0,0};
 histo[C[im1][jm1]] ++;
 histo[C[im1][j]] ++;
 histo[C[im1][jp1]] ++;
 histo[C[i][jm1]] ++;
 histo[C[i][jp1]] ++;
 histo[C[ip1][jm1]] ++;
 histo[C[ip1][j]] ++;
 histo[C[ip1][jp1]] ++;
 // condition : au moins 3 voisins de (i,j) dans l'etat suivant
 return (histo[(C[i][j]+1)%4] >= 3);
}
